#include "Point.h"
#include <iostream>

Point::Point() {
   x = 0;
   y = 0;
   z = 0;
}

Point::Point(float _x, float _y, float _z) {
   x = _x;
   y = _y;
   z = _z;
}

Point::Point(const Point &src) {
   x = src.x;
   y = src.y;
   z = src.z;
}

Point Point::operator+ (const Point &rhs) const {
   Point tmp;
   tmp.x = x + rhs.x;
   tmp.y = y + rhs.y;
   tmp.z = z + rhs.z;
   return tmp;
}

Point Point::operator+ (const Vector &rhs) const {
   Point tmp;
   tmp.x = x + rhs.x;
   tmp.y = y + rhs.y;
   tmp.z = z + rhs.z;
   return tmp;
}

Point Point::operator- (const Point &rhs) const {
   Point tmp;
   tmp.x = x - rhs.x;
   tmp.y = y - rhs.y;
   tmp.z = z - rhs.z;
   return tmp;
}

Point Point::operator= (const Point &rhs) {
   x = rhs.x;
   y = rhs.y;
   z = rhs.z;
   return *this;
}

void Point::operator= (const float *arr) {
   x = arr[0];
   y = arr[1];
   z = arr[2];
}

int Point::operator== (const Point &rhs) const {
   return (x == rhs.x && y == rhs.y && z == rhs.z);
}

Point Point::operator/ (float scalar) const {
   Point tmp;
   tmp.x = x / scalar;
   tmp.y = y / scalar;
   tmp.z = z / scalar;
   return tmp;
}

void Point::setXYZ(float _x, float _y, float _z) {
   x = _x;
   y = _y;
   z = _z;
}

std::ostream &operator<<(std::ostream &os, const Point &point) {
   os << "(" << point.x << "," << point.y << "," << point.z << ")";
   return os;
}

