#ifndef HMC_POINT
#define HMC_POINT

#include <iostream>
#include "Vector.h"

struct Vector;

struct Point {
   union {
      struct {
         float x, y, z;
      };
      struct {
         float xyz[3];
      };
   };
   
   Point();
   Point(float _x, float _y, float _z);
   Point(const Point &src);
   
   Point operator+ (const Point &rhs) const;
   Point operator+ (const Vector &rhs) const;
   Point operator- (const Point &rhs) const;

   Point  operator= (const Point &rhs);
   void operator= (const float *arr);
   int   operator== (const Point &rhs) const;
   Point operator/ (float scalar) const;
   void setXYZ(float _x, float _y, float _z);

   friend std::ostream &operator<< (std::ostream &os, const Point &point);
};
#endif
